#include "DbgCube.hpp"


ObjectDbgCube::ObjectDbgCube() {
    try {
        mMesh.vertices.resize(8);
    } catch (const std::length_error& ex) {
        throw ex;
    }

    mMesh.vertices[0] = { M3D_F3(0.5f, 0.5f, 0.5f), sf::Color::White};
    mMesh.vertices[1] = { M3D_F3(0.5f, -0.5f, 0.5f), sf::Color::Green};
    mMesh.vertices[2] = { M3D_F3(-0.5f, 0.5f, 0.5f), sf::Color::Yellow};
    mMesh.vertices[3] = { M3D_F3(-0.5f, -0.5f, 0.5f), sf::Color::Cyan};
    mMesh.vertices[4] = { M3D_F3(0.5f, 0.5f, -0.5f), sf::Color::Blue};
    mMesh.vertices[5] = { M3D_F3(0.5f, -0.5f, -0.5f), sf::Color::Red};
    mMesh.vertices[6] = { M3D_F3(-0.5f, 0.5f, -0.5f), sf::Color::Magenta};
    mMesh.vertices[7] = { M3D_F3(-0.5f, -0.5f, -0.5f), sf::Color::Black};

    MeshPart basePart;
    MHELPER_INDICES_TRI_ADD(basePart.indices, 4, 2, 0);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 2, 7, 3);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 6, 5, 7);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 1, 7, 5);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 0, 3, 1);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 4, 1, 5);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 4, 6, 2);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 2, 6, 7);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 6, 4, 5);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 1, 3, 7);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 0, 2, 3);
    MHELPER_INDICES_TRI_ADD(basePart.indices, 4, 0, 1);
    mMesh.parts.push_back(basePart);
}