#include <iomanip>

#include "Game.hpp"


int main(int argc, char** argv) {
    SysTimer mSysTimer;
    std::cout << std::fixed << std::setprecision(6);

    GAME_STATUS status = GAME_INIT;

    std::cout << "[" << mSysTimer.GetElapsedTimeS() << "] Init game instance" << std::endl;
    Game& arcadeGame = Game::getInstance(true);

    for ( ;; ) {
        status = arcadeGame.Tick(mSysTimer);

        if (status == GAME_QUIT)
            break;
    }

    std::cout << "[" << mSysTimer.GetElapsedTimeS() << "] Bye bye!" << std::endl;
	return EXIT_SUCCESS;
}
