from conan import ConanFile
from conan.tools.cmake import CMakeToolchain#,cmake_layout
from conan.tools.files import copy
import os

required_conan_version = ">=1.59"

class ProtoTank(ConanFile):
    name = "ProtoTank"
    version = "0.1"
    description = """Demo/PoC project
                    Arcade 80s-style game with tanks"""
    license = "MIT"
    author = "JackCarterSmith (j@jcsmith.fr)"
    url = "https://git.jcsmith.fr/JCS-Prod/ProtoTank"
    
    package_type = "application"
    revision_mode = "scm"
    settings = "os", "compiler", "build_type", "arch"
    generators = "CMakeDeps"
    
    
    def configure(self):
        self.options["sfml"].audio = True
        self.options["sfml"].window = True
        self.options["sfml"].network = False
        self.options["sfml"].graphics = True
        
        if self.settings.os == "Linux":
            self.options["sfml"].shared = False
            self.options["sfml"].fPIC = True
            
        if self.settings.os == "Windows":
            self.options["sfml"].shared = True
    
    def requirements(self):
        self.requires("sfml/[~2.6]")
        
#    def layout(self):
#        cmake_layout(self)
        
    def generate(self):
        tc = CMakeToolchain(self)
        #tc.user_presets_path = False
        tc.generate()
        for dep in self.dependencies.values():
            if len(dep.cpp_info.bindirs) > 0:
                if self.settings.os == "Windows":
                    copy(self, "*.dll", dep.cpp_info.bindirs[0], os.path.join(self.build_folder, "bin"))
                else:
                    copy(self, "*.so", dep.cpp_info.bindirs[0], os.path.join(self.build_folder, "bin"))

#    def package(self):
#        copy(self, "LICENSE", src=self.source_folder, dst=os.path.join(self.package_folder, "licenses"))
#        copy(self, pattern="*.h", src=os.path.join(self.source_folder, "include"), dst=os.path.join(self.package_folder, "include"))
#        copy(self, pattern="*.a", src=self.build_folder, dst=os.path.join(self.package_folder, "lib"), keep_path=False)
#        copy(self, pattern="*.so", src=self.build_folder, dst=os.path.join(self.package_folder, "lib"), keep_path=False)
#        copy(self, pattern="*.lib", src=self.build_folder, dst=os.path.join(self.package_folder, "lib"), keep_path=False)
#        copy(self, pattern="*.dll", src=self.build_folder, dst=os.path.join(self.package_folder, "bin"), keep_path=False)
